"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const command_1 = require("@oclif/command");
const flags_1 = require("@oclif/command/lib/flags");
const core_1 = require("@nestjs/core");
const oclif_service_1 = require("./oclif.service");
class BaseCommand extends command_1.default {
    static register(bootstrapOptions) {
        BaseCommand.bootstrapOptions = bootstrapOptions;
    }
    async init() {
        const output = this.parse(this.constructor);
        BaseCommand.cmdContext = {
            args: output.args,
            flags: output.flags,
        };
        this.app = await core_1.NestFactory.createApplicationContext(BaseCommand.bootstrapOptions.nestModule);
        if (BaseCommand.bootstrapOptions.enableShutdownHooks) {
            this.app.enableShutdownHooks();
        }
    }
    async run() {
        await this.app.get(oclif_service_1.OclifService).run(this.app, this.constructor.name);
    }
    async finally() {
        if (this.app) {
            await this.app.close();
        }
    }
}
exports.BaseCommand = BaseCommand;
BaseCommand.flags = {
    help: flags_1.help({ char: 'h' }),
};
//# sourceMappingURL=base.command.js.map