"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const oclifArgs_decorator_1 = require("./oclifArgs.decorator");
const oclifFlags_decorator_1 = require("./oclifFlags.decorator");
const base_command_1 = require("./base.command");
function buildProviderFor(type) {
    return (key) => {
        if (key === '') {
            return {
                provide: `oclif.${type}`,
                useFactory: () => base_command_1.BaseCommand.cmdContext[type],
            };
        }
        return {
            provide: `oclif.${type}.${key}`,
            useFactory: () => base_command_1.BaseCommand.cmdContext[type][key],
        };
    };
}
function oclifProviders(provideFlags, provideArgs) {
    const flags = new Set(oclifFlags_decorator_1.flagKeys.concat(provideFlags || []));
    const flagsProviders = Array.from(flags).map(buildProviderFor('flags'));
    const args = new Set(oclifArgs_decorator_1.argKeys.concat(provideArgs || []));
    const argsProviders = Array.from(args).map(buildProviderFor('args'));
    return flagsProviders.concat(argsProviders);
}
exports.oclifProviders = oclifProviders;
//# sourceMappingURL=oclif.providers.js.map